/*
 * !++
 * QDS - Quick Data Signalling Library
 * !-
 * Copyright (C) 2002 - 2017 Devexperts LLC
 * !-
 * This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
 * If a copy of the MPL was not distributed with this file, You can obtain one at
 * http://mozilla.org/MPL/2.0/.
 * !__
 */
package com.devexperts.services;

import java.lang.annotation.*;

/**
 * Marks class that provides a certain {@link Service} via services provider framework.
 */
@Retention(RetentionPolicy.RUNTIME)
@Documented
@Target(ElementType.TYPE)
public @interface ServiceProvider {
	/**
	 * The order of this service provider with respect to other providers.
	 * {@link Services#createServices(Class, ClassLoader) createServices} method
	 * returns service providers in the specified order.
	 */
	public int order() default 0;
}
